/*
 * Copyright (C) 2007 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package com.android.unit_tests;

import android.test.TestListActivity;

public class AndroidPerformanceTests extends TestListActivity {
    @Override
    public String getTestSuite() {
        return "com.android.unit_tests.AndroidPerformanceTests$Suite";
    }

    public static class Suite {
        public static String[] children() {
            return new String[] {
                DatabasePerformanceTests.class.getName(),
                GraphicsPerformanceTests.class.getName(),
                JavaPerformanceTests.class.getName(),
                LogTest.PerformanceTest.class.getName(),
                PerformanceTests.class.getName(),
                TextViewPerformanceTest.class.getName(),
            };
        }
    }
}
